/*
 * Bluecell_operate.h
 *
 *  Created on: 2020. 4. 3.
 *      Author: YJ
 */

#ifndef BLUECELL_OPERATE_H_
#define BLUECELL_OPERATE_H_


#include <stdbool.h>
#include "Bluecell_operate.h"
/*
SYN
Sub-UID
R-Code
TR-ID
Seq-Num
TTL
Time
 
CMD
Length
Header Checksum
SUB-DATA
SUB-DATA-CRC
ETX
 */


/*
 *
0	80	ü  ȸ	 AID ׸   û   (û Frame SUB-DATA  ̴ 0)
1	81	 û	 û REQ 0x01 ̰  ü  ¸ 

10	90	Download Notification	ٿε 
11	91	Download Data	ٿε data
12	92	Download Confirm	ٿε Ȯ
13	93	Download Complete	Download Complete Command
14	94	System-Reboot	System Rebooting Command

40	C0	̺ ȸ  
41	C1	̺   

 *
 *
 */
typedef enum{
	AllDataReq = 0,      // -> Response 80
	DataCtrlReq,		 // -> Response 81
	DownNotification,    // -> Response 90
	DownData,            // -> Response 91
	DownConfirm ,        // -> Response 92
	DownComplete,        // -> Response 93
	SystemReboot,        // -> Response 94

	TableDataReq = 40,

};
#endif /* BLUECELL_OPERATE_H_ */
