/*
 * PE43711.h
 *
 *  Created on: 2019. 6. 28.
 *      Author: parkyj
 */

#ifndef PE43711_H_
#define PE43711_H_
#include "main.h"
 void PE43711_PinInit(void);


 typedef struct{
    GPIO_TypeDef * CLK_PORT;
    uint16_t CLK_PIN;

    GPIO_TypeDef *DATA_PORT;
    uint16_t DATA_PIN;

    GPIO_TypeDef *LE_PORT;
    uint16_t LE_PIN;
 }PE43711_st;
 
 typedef struct{
   PE43711_st ATT0;
   uint8_t    data0;
   PE43711_st ATT1;
   uint8_t    data1;
   PE43711_st ATT2;
   uint8_t    data2;
   PE43711_st ATT3;
   uint8_t    data3;
   PE43711_st ATT4;    
   uint8_t    data4;
   PE43711_st ATT5;    
   uint8_t    data5;
 }ALL_PE43711_st;
ALL_PE43711_st ALL_ATT_3_5G;


#endif /* PE43711_H_ */
